-- Calc.applescript
-- Calc

--  Created by Nico Rohrbach on 29.01.06.
--  Copyright 2004 - 2006 Superpixel. All rights reserved.

property the_calculation : ""
property the_result : ""


on changed theObject
	my calculate()
end changed


on clicked theObject
	
	if name of theObject is "clear" then
		if name of theObject is "clear" then
			set contents of text view "calculation" of scroll view "calculation" of window "main" to ""
			set contents of text field "result" of window "main" to "="
		end if
		
	else if name of theObject is "copy" then
		set my_output to trim_line(the_result, "=", 0)
		set the clipboard to my_output
		
	end if
end clicked


on should quit after last window closed theObject
	return true
end should quit after last window closed

on launched theObject
	tell text view "calculation" of scroll view "calculation" of window "main"
		set theFont to call method "fontWithName:size:" of class "NSFont" with parameters {"Lucida Grande", 12}
		call method "setFont:" of object it with parameter theFont
	end tell
end launched


on read_from_UI()
	set the_calculation to contents of text view "calculation" of scroll view "calculation" of window "main"
end read_from_UI


on write_to_UI()
	set contents of text field "result" of window "main" to the_result
end write_to_UI


on calculate()
	-- get calculation from the UI
	read_from_UI()
	-- calculate using bc
	try
		set the_result to "=" & (do shell script "/bin/echo" & space & 
			(quoted form of the_calculation) & space & "|" & space & "/usr/bin/bc -l") as text
	end try
	-- remove unnecessary zeros at end
	if the_result contains "." then
		set the_result to trim_line(the_result, "0", 1)
	end if
	-- remove unnecessary dot at end
	if last character of the_result is "." then
		set the_result to trim_line(the_result, ".", 1)
	end if
	-- write the result to UI
	write_to_UI()
end calculate


(* handler from apple to trim strings *)
on trim_line(this_text, trim_chars, trim_indicator)
	-- 0 = beginning, 1 = end, 2 = both
	set x to the length of the trim_chars
	-- TRIM BEGINNING
	if the trim_indicator is in {0, 2} then
		repeat while this_text begins with the trim_chars
			try
				set this_text to characters (x + 1) thru -1 of this_text as string
			on error
				-- the text contains nothing but the trim characters
				return ""
			end try
		end repeat
	end if
	-- TRIM ENDING
	if the trim_indicator is in {1, 2} then
		repeat while this_text ends with the trim_chars
			try
				set this_text to characters 1 thru -(x + 1) of this_text as string
			on error
				-- the text contains nothing but the trim characters
				return ""
			end try
		end repeat
	end if
	return this_text
end trim_line

